/// <reference types="node" />
import express from 'express';
import http from 'http';
declare type RequestVerbs = 'get' | 'post' | 'put' | 'patch' | 'delete';
declare type Payload = any;
declare class ExternalResponse {
    app: express.Application;
    method: RequestVerbs;
    route: string;
    spyFn?: (payload: Payload) => void;
    constructor(app: express.Application, method: RequestVerbs, route: string);
    spy(fn: (payload: Payload) => void): this;
    reply(code: number, body: Payload): void;
}
declare class ExternalMock {
    app: express.Application;
    server: http.Server;
    constructor(port: number);
    close(): void;
    get(route: string): ExternalResponse;
    post(route: string): ExternalResponse;
    put(route: string): ExternalResponse;
    patch(route: string): ExternalResponse;
    delete(route: string): ExternalResponse;
}
export declare const createMock: (port: number) => ExternalMock;
export declare const cleanExternalMocks: () => void;
export {};
